package kr.co.icontrols.ilp300_700.admin.test;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.widget.RelativeLayout;

import kr.co.icontrols.ilp300_700.MainActivity;
import kr.co.icontrols.ilp300_700.R;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValue;
import kr.co.icontrols.ilp300_700.global.DataClasses.POSITION;
import kr.co.icontrols.ilp300_700.global.Declare;
import kr.co.icontrols.ilp300_700.global.ID;
import kr.co.icontrols.wallpadsupport.WpadImageView;
import kr.co.icontrols.wallpadsupport.WpadScreen;
import kr.co.icontrols.wallpadsupport.WpadTextView;

public class AdminSet_Test_Sensors extends WpadScreen {

    String TAG = "AdminSet_Test_Sensors";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = false;   // true, false
    boolean bLOG_INFO = false;   // true, false
    Context mContext;
    WpadImageView Image_Background;
    WpadTextView Text_Title;
    WpadTextView Text_Line_01_Item;
    WpadTextView Text_Line_02_Item;
    WpadTextView Text_Line_03_Item;
    WpadTextView Text_Line_04_Item;
    WpadTextView Text_Line_01_Input;
    WpadTextView Text_Line_02_Input;
    WpadTextView Text_Line_03_Input;
    WpadTextView Text_Line_04_Input;
    int TextColor_Normal = Color.WHITE;
    int TextColor_Highlight = Color.GREEN;
    int TextColor_Red = Color.RED;
    int nFontSize_Instruction = 28;
    boolean bFontNonBold = false;
    boolean bFontBold = true;
    String strText_Title = "내부/외부 센서";
    String strText_Line_01_Item = "1] 내부센서";
    String strText_Line_02_Item = "2] 외부센서";
    String strText_Line_03_Item = "";
    String strText_Line_01_Input = "";
    String strText_Line_02_Input = "";
    String strText_Line_03_Input = "";
    boolean bMotionSensorActive = false;
    boolean bFireSensorActive = false;
    boolean bExternalSensorActive = false;

    public AdminSet_Test_Sensors(Context context, RelativeLayout layout) {
        super(context, layout);
        try {
            LOG("------------------ [START - AdminSet_Test_Sensors] -------------------");

            mContext = context;
            Initialize();

            Image_Background = new WpadImageView(context, 0, Declare.DeviceInfo.getScreenSizeFullW(ConfigValue.DEVICE_MODELTYPE), Declare.DeviceInfo.getScreenSizeFullH(ConfigValue.DEVICE_MODELTYPE), R.drawable.bg_back, 0, ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.IMAGES.BACKGROUND);
            ViewRegistration(layout, Image_Background, 0, 0);

            Text_Title = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.TITLE).W, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.TITLE).H, Gravity.CENTER, Color.WHITE, nFontSize_Instruction, bFontBold, ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.TITLE);
            ViewRegistration(layout, Text_Title, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.TITLE).X, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.TITLE).Y);
            Text_Title.setText(strText_Title);

            Text_Line_01_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Item);
            ViewRegistration(layout, Text_Line_01_Item, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Item).Y);
            Text_Line_01_Item.setText(strText_Line_01_Item);

            Text_Line_02_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Item);
            ViewRegistration(layout, Text_Line_02_Item, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Item).Y);
            Text_Line_02_Item.setText(strText_Line_02_Item);

            Text_Line_03_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Item).W, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Item);
            ViewRegistration(layout, Text_Line_03_Item, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Item).X, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Item).Y);
            Text_Line_03_Item.setText(strText_Line_03_Item);

            Text_Line_01_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Input).W, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Input);
            ViewRegistration(layout, Text_Line_01_Input, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Input).X, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Input).Y);
            Text_Line_01_Input.setText(strText_Line_01_Input);

            Text_Line_02_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Input).W, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Input);
            ViewRegistration(layout, Text_Line_02_Input, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Input).X, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Input).Y);
            Text_Line_02_Input.setText(strText_Line_02_Input);

            Text_Line_03_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Input).W, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Input);
            ViewRegistration(layout, Text_Line_03_Input, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Input).X, getPosition(ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Input).Y);
            Text_Line_03_Input.setText(strText_Line_03_Input);

            UpdateScreen();
            ((MainActivity) mContext).setAutoScreenChange(ID.SCREENS.Main, MainActivity.nAdminScreenTimeout);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] AdminSet_Test_Sensors(Context context, RelativeLayout layout)");
            e.printStackTrace();
        }
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    protected void Initialize() {
        try {
            LOG("[Initialize] ===== START =====");
            if (MainActivity.mIOInterface.getDoorswitchSensorStatus() == 1) bMotionSensorActive = true;
            else bMotionSensorActive = false;

            if (MainActivity.mIOInterface.getFireSensorStatus() == 1) bFireSensorActive = true;
            else bFireSensorActive = false;

            if (MainActivity.mIOInterface.getExternalSensorStatus() == 1) bExternalSensorActive = true;
            else bExternalSensorActive = false;

            Log.i(TAG, "[Initialize] bMotionSensorActive [" + bMotionSensorActive + "], bFireSensorActive [" + bFireSensorActive + "], bExternalSensorActive [" + bExternalSensorActive + "]");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] Initialize()");
            e.printStackTrace();
        }
    }

    @Override
    protected void onClose() {
        try {
            LOG("------------------ [onClose - AdminSet_Test_Sensors] -------------------");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onClose() : " + e);
            e.printStackTrace();
        }
        super.onClose();
    }

    @Override
    protected void onBrReceive(Intent intent) {
        try {
            LOG("[onBrReceive] Intent : " + intent);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onBrReceive(Intent intent)");
            e.printStackTrace();
        }
        super.onBrReceive(intent);
    }

    @Override
    protected void onKeyDown(int keyCode, KeyEvent event) {
        try {
//            LOG("[onKeyDown] keyCode [" + keyCode + "], event [" + event + "]");
            if (keyCode == Declare.Button.INSIDESENSOR_ACTIVE) {
                ((MainActivity) mContext).extendAutoScreenChangeTime();
                bMotionSensorActive = true;
            }
            else if (keyCode == Declare.Button.INSIDESENSOR_INACTIVE) {
                ((MainActivity) mContext).extendAutoScreenChangeTime();
                bMotionSensorActive = false;
            }
            else if (keyCode == Declare.Button.OUTSIDESENSOR_ACTIVE) {
                ((MainActivity) mContext).extendAutoScreenChangeTime();
                bExternalSensorActive = true;
            }
            else if (keyCode == Declare.Button.OUTSIDESENSOR_INACTIVE) {
                ((MainActivity) mContext).extendAutoScreenChangeTime();
                bExternalSensorActive = false;
            }
            else if (keyCode == Declare.Button.CANCEL || keyCode == Declare.Button.TACT_CANCEL) {
                super.setChangeScreen(ID.SCREENS.AdminSet_Test);
            }

            UpdateScreen();
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onKeyDown(int keyCode, KeyEvent event)");
            e.printStackTrace();
        }
        super.onKeyDown(keyCode, event);
    }

    protected void UpdateScreen() {
        try {
//            LOG("[updateScreen] ===== START =====");
            if (bMotionSensorActive) {
                strText_Line_01_Input = "[감지됨]";
                Text_Line_01_Input.setTextColor(Color.GREEN);
            }
            else {
                strText_Line_01_Input = "[감지안됨]";
                Text_Line_01_Input.setTextColor(Color.WHITE);
            }

            if (bExternalSensorActive) {
                strText_Line_02_Input = "[감지됨]";
                Text_Line_02_Input.setTextColor(Color.GREEN);
            }
            else {
                strText_Line_02_Input = "[감지안됨]";
                Text_Line_02_Input.setTextColor(Color.WHITE);
            }

//            if (bExternalSensorActive) strText_Line_03_Input = "감지됨";
//            else strText_Line_03_Input = "감지안됨";

            Text_Title.setText(strText_Title);
            Text_Line_01_Input.setText(strText_Line_01_Input);
            Text_Line_02_Input.setText(strText_Line_02_Input);
//            Text_Line_03_Item.setText(strText_Line_03_Item);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] updateScreen()");
            e.printStackTrace();
        }
    }

    public POSITION getPosition(int nID) {
//        LOG("[getPosition] ===== START =====");
        POSITION position = new POSITION();
        position.SetPosition(0, 0, 480, 272);
        try {
            switch (nID) {
                case ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.IMAGES.BACKGROUND:
                    position.SetPosition(0, 0, 480, 272);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.TITLE:
                    position.SetPosition(0, 24, 480, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Item:
                    position.SetPosition(50, 84, 150, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Item:
                    position.SetPosition(50, 134, 150, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Item:
                    position.SetPosition(50, 184, 150, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_01_Input:
                    position.SetPosition(220, 84, 260, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_02_Input:
                    position.SetPosition(220, 134, 260, 40);
                    return position;

                case ID.SCREENS.ADMINSET_TEST_MOTIONSENSOR.ELEMENTS.TEXTS.LINE_03_Input:
                    position.SetPosition(220, 184, 260, 40);
                    return position;

                default:
                    return position;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] getPosition() : " + e);
            e.printStackTrace();
            return position;
        }
    }


}